-- from /XrnxStarterPack280/Snippets/Osc.lua

-- create some handy shortcuts
local OscMessage = renoise.Osc.Message
local OscBundle = renoise.Osc.Bundle


-- Osc client & message construction (send Osc to a server)

-- open a socket connection to the server
local client, socket_error = renoise.Socket.create_client(
  "localhost", 8008, renoise.Socket.PROTOCOL_UDP)
   
if (socket_error) then 
  renoise.app():show_warning(("Failed to start the " .. 
    "OSC client. Error: '%s'"):format(socket_error))
  return
end
------------------------------------------

function ptn_name(ptn_idx)
  local name =
  renoise.song().patterns[ptn_idx].name
  return name
end

function selected_ptn()
  return
  renoise.song().selected_pattern_index
end
  
--  send Text to Pd
function txt2pd(txt,stream)
  client:send(
    OscMessage(
      "/pd/"..tostring(stream).."/text",
      {{
        tag= "s",
        value= txt
      }}
    )
  )
end

function reset_txt2pd(int,stream)
  client:send(
    OscMessage(
      "/pd/"..tostring(stream).."/resettext",
      {{
        tag= "i",
        value= int
      }}
    )
  )
end

function bang2pd(int,stream)
  client:send(
    OscMessage(
      "/pd/"..tostring(stream).."/bang",
      {{
        tag= "i",
        value= int
      }}
    )
  )
end

function rotatex2pd(int,stream)
  client:send(
    OscMessage(
      "/pd/"..tostring(stream).."/rotatex",
      {{
        tag= "i",
        value= int
      }}
    )
  )
end


-- test



txt2pd(ptn_name(selected_ptn()),1)

txt2pd("RenoisePd Test",1)

rotatex2pd(48,1)

bang2pd(1,1)

--Reset
reset_txt2pd(1,1)


  